'use strict';

var interpolateSelectors = require('./interpolateSelectors');

var KEBAB_REGEX = /[A-Z]/g;

exports.toCss = function toCss (pojso) {
    var str = '';

    for (var selector in pojso) {
        var values = pojso[selector];

        // Atrule: @media, @keyframe, ...
        if (selector[0] === '@') {
            str += selector + '{' + toCss(values) + '}';
        } else {
            var selectors = selector.split(',');
            var declarations = '';

            for (var prop in values) {
                var value = values[prop];

                switch (typeof value) {
                case 'string':
                case 'number':
                    prop = prop.replace(KEBAB_REGEX, '-$&').toLowerCase();
                    declarations += prop + ':' + value + ';';
                    break;
                case 'object': {
                    var selectorsInterpolated = interpolateSelectors(selectors, prop);
                    var obj = {};
                    obj[selectorsInterpolated] = value;
                    str += toCss(obj);
                    break;
                }
                }
            }
            str += selectors + '{' + declarations + '}';
        }
    }

    return str;
};
